/************************************************************************/
/*                                                                      */
/*                      RC5 Remote Receiver                             */
/*                                                                      */
/*              Author: Peter Dannegger                                 */
/*                      danni@specs.de                                  */
/* abgenderte Version fr AT90S2313  angepasst   10.1.2013             */
/* Neu hinzugefgt: Drehwinkel-Encoder-Auswertung 23.6.2014				*/
/* zeigt auf dem LCD den RC5-Code und zhlt eine Byte-Variable hoch und runter */
/* getestet mit Pollin Encoder PANASONIC EVEQDBRL416B					*/
/* der Pollin-Drehgeber macht pro Rastung zwei Schritte					*/
/* bei ganz langsamem Drehen erkennt man einzelne Schritte.				*/
/* knnte zum DDS-Generator Andreas Schwarz passen						*/
/************************************************************************/

//#include "main.h"
#include "main_2313.h"
#include "LCD-Routines.h"
#include <util/delay.h>
//#include <io.h>
//#include <interrupt.h>
//#include <signal.h>
//#include <stdlib.h>


int main( void )
{
  uint i;
  char s[10];

  TCCR0 = 1<<CS02;			//divide by 256
  TIMSK = 1<<TOIE0;			//enable timer interrupt

 
/*
    DDRB = 0xff;    // PortD als Ausgang deklarieren
    PORTB = 0x00;   // Ports auf LOW schalten

Table 18. DDBn Effects on Port B Pins(1)
DDBn PORTBn I/O 	Pull-up Comment
0 		0 	Input 	No 		Tri-state (High-Z)
0 		1 	Input 	Yes 	PBn will source current if ext. pulled low
1 		0 	Output 	No 		Push-pull Zero Output
1 		1 	Output 	No 		Push-pull One Output
_______________________________________________________________________


*/

//Drehencoder ist an PB0 = AIN0 und PB1= AIN1 angeschlossen

DDRB = 0b00001100;	//PB3 und PB2 als Ausgnge, um LEDs zu toggeln

PORTB = 0b00010011;   // PortD , PD6 auf Pullup= ein schalten fr IR-Empfnger und PB0 und PB1 fr Drehencoder


lcd_init();

lcd_string("Hello World!");
//_delay_ms( 600);
lcd_setcursor( 0, 2 );		//Spalte 0, Zeile1

//   lcd_clear();

  sei();

  for(;;){				// main loop
    cli();
//	PORTB ^= (1 << PB2);    // LED toggeln PB2
//	PORTB ^= (1 << PB3);    // LED toggeln PB3
		
	
    i = rc5_data;			// read two bytes from interrupt !
    rc5_data = 0;
    sei();
    if( i ){
	
	lcd_setcursor( 0, 2 );		//Spalte 0, Zeile1
	lcd_data( ( i >> 11 & 1) + '0' );
	  
	lcd_data( ' ');
	  
    itoa( i >> 6 & 0x1F, s, 10);	// Device address
	lcd_string( s );
	  
	lcd_data( ' ');
	  
    itoa((i & 0x3F) | (~i >> 7 & 0x40), s, 10); // Key Code   s ist ein character-array mit 30 Zeichen
	lcd_string( s );

	  
	_delay_ms( 50 );
//	lcd_setcursor( 0, 2 );		//Spalte 0, Zeile1

	
    }
	
	 _delay_ms( 50 );
		 
    lcd_setcursor( 8, 2 );		//Spalte 8, Zeile2
	itoa( enc_delta, s, 10);	//zhlt eine 8-bit-Zahl hoch und runter 0..255 wie gewnscht!! macht allerdings immer 2er Schritte bi jedem Raster!!		 
	lcd_string( s );
	 
  }							//Ende for;;
  return 0;
 }
